import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface ApiGatewayAccountConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_account.html#cloudwatch_role_arn ApiGatewayAccount#cloudwatch_role_arn}.
     *
     * @stability stable
     */
    readonly cloudwatchRoleArn?: string;
}
/**
 * @stability stable
 */
export declare class ApiGatewayAccountThrottleSettings extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get burstLimit(): number;
    /**
     * @stability stable
     */
    get rateLimit(): number;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_account.html aws_api_gateway_account}.
 *
 * @stability stable
 */
export declare class ApiGatewayAccount extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/api_gateway_account.html aws_api_gateway_account} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: ApiGatewayAccountConfig);
    private _cloudwatchRoleArn?;
    /**
     * @stability stable
     */
    get cloudwatchRoleArn(): string;
    /**
     * @stability stable
     */
    set cloudwatchRoleArn(value: string);
    /**
     * @stability stable
     */
    resetCloudwatchRoleArn(): void;
    /**
     * @stability stable
     */
    get cloudwatchRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    throttleSettings(index: string): ApiGatewayAccountThrottleSettings;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
