import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface AutoscalingGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#availability_zones AutoscalingGroup#availability_zones}.
     *
     * @stability stable
     */
    readonly availabilityZones?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#capacity_rebalance AutoscalingGroup#capacity_rebalance}.
     *
     * @stability stable
     */
    readonly capacityRebalance?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#default_cooldown AutoscalingGroup#default_cooldown}.
     *
     * @stability stable
     */
    readonly defaultCooldown?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#desired_capacity AutoscalingGroup#desired_capacity}.
     *
     * @stability stable
     */
    readonly desiredCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#enabled_metrics AutoscalingGroup#enabled_metrics}.
     *
     * @stability stable
     */
    readonly enabledMetrics?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#force_delete AutoscalingGroup#force_delete}.
     *
     * @stability stable
     */
    readonly forceDelete?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#force_delete_warm_pool AutoscalingGroup#force_delete_warm_pool}.
     *
     * @stability stable
     */
    readonly forceDeleteWarmPool?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#health_check_grace_period AutoscalingGroup#health_check_grace_period}.
     *
     * @stability stable
     */
    readonly healthCheckGracePeriod?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#health_check_type AutoscalingGroup#health_check_type}.
     *
     * @stability stable
     */
    readonly healthCheckType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#launch_configuration AutoscalingGroup#launch_configuration}.
     *
     * @stability stable
     */
    readonly launchConfiguration?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#load_balancers AutoscalingGroup#load_balancers}.
     *
     * @stability stable
     */
    readonly loadBalancers?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#max_instance_lifetime AutoscalingGroup#max_instance_lifetime}.
     *
     * @stability stable
     */
    readonly maxInstanceLifetime?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#max_size AutoscalingGroup#max_size}.
     *
     * @stability stable
     */
    readonly maxSize: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#metrics_granularity AutoscalingGroup#metrics_granularity}.
     *
     * @stability stable
     */
    readonly metricsGranularity?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#min_elb_capacity AutoscalingGroup#min_elb_capacity}.
     *
     * @stability stable
     */
    readonly minElbCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#min_size AutoscalingGroup#min_size}.
     *
     * @stability stable
     */
    readonly minSize: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#name AutoscalingGroup#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#name_prefix AutoscalingGroup#name_prefix}.
     *
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#placement_group AutoscalingGroup#placement_group}.
     *
     * @stability stable
     */
    readonly placementGroup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#protect_from_scale_in AutoscalingGroup#protect_from_scale_in}.
     *
     * @stability stable
     */
    readonly protectFromScaleIn?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#service_linked_role_arn AutoscalingGroup#service_linked_role_arn}.
     *
     * @stability stable
     */
    readonly serviceLinkedRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#suspended_processes AutoscalingGroup#suspended_processes}.
     *
     * @stability stable
     */
    readonly suspendedProcesses?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#tags AutoscalingGroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#target_group_arns AutoscalingGroup#target_group_arns}.
     *
     * @stability stable
     */
    readonly targetGroupArns?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#termination_policies AutoscalingGroup#termination_policies}.
     *
     * @stability stable
     */
    readonly terminationPolicies?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#vpc_zone_identifier AutoscalingGroup#vpc_zone_identifier}.
     *
     * @stability stable
     */
    readonly vpcZoneIdentifier?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#wait_for_capacity_timeout AutoscalingGroup#wait_for_capacity_timeout}.
     *
     * @stability stable
     */
    readonly waitForCapacityTimeout?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#wait_for_elb_capacity AutoscalingGroup#wait_for_elb_capacity}.
     *
     * @stability stable
     */
    readonly waitForElbCapacity?: number;
    /**
     * initial_lifecycle_hook block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#initial_lifecycle_hook AutoscalingGroup#initial_lifecycle_hook}
     *
     * @stability stable
     */
    readonly initialLifecycleHook?: AutoscalingGroupInitialLifecycleHook[];
    /**
     * instance_refresh block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#instance_refresh AutoscalingGroup#instance_refresh}
     *
     * @stability stable
     */
    readonly instanceRefresh?: AutoscalingGroupInstanceRefresh[];
    /**
     * launch_template block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#launch_template AutoscalingGroup#launch_template}
     *
     * @stability stable
     */
    readonly launchTemplate?: AutoscalingGroupLaunchTemplate[];
    /**
     * mixed_instances_policy block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#mixed_instances_policy AutoscalingGroup#mixed_instances_policy}
     *
     * @stability stable
     */
    readonly mixedInstancesPolicy?: AutoscalingGroupMixedInstancesPolicy[];
    /**
     * tag block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#tag AutoscalingGroup#tag}
     *
     * @stability stable
     */
    readonly tag?: AutoscalingGroupTag[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#timeouts AutoscalingGroup#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: AutoscalingGroupTimeouts;
    /**
     * warm_pool block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#warm_pool AutoscalingGroup#warm_pool}
     *
     * @stability stable
     */
    readonly warmPool?: AutoscalingGroupWarmPool[];
}
/**
 * @stability stable
 */
export interface AutoscalingGroupInitialLifecycleHook {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#default_result AutoscalingGroup#default_result}.
     *
     * @stability stable
     */
    readonly defaultResult?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#heartbeat_timeout AutoscalingGroup#heartbeat_timeout}.
     *
     * @stability stable
     */
    readonly heartbeatTimeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#lifecycle_transition AutoscalingGroup#lifecycle_transition}.
     *
     * @stability stable
     */
    readonly lifecycleTransition: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#name AutoscalingGroup#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#notification_metadata AutoscalingGroup#notification_metadata}.
     *
     * @stability stable
     */
    readonly notificationMetadata?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#notification_target_arn AutoscalingGroup#notification_target_arn}.
     *
     * @stability stable
     */
    readonly notificationTargetArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#role_arn AutoscalingGroup#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupInstanceRefreshPreferences {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#instance_warmup AutoscalingGroup#instance_warmup}.
     *
     * @stability stable
     */
    readonly instanceWarmup?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#min_healthy_percentage AutoscalingGroup#min_healthy_percentage}.
     *
     * @stability stable
     */
    readonly minHealthyPercentage?: number;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupInstanceRefresh {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#strategy AutoscalingGroup#strategy}.
     *
     * @stability stable
     */
    readonly strategy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#triggers AutoscalingGroup#triggers}.
     *
     * @stability stable
     */
    readonly triggers?: string[];
    /**
     * preferences block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#preferences AutoscalingGroup#preferences}
     *
     * @stability stable
     */
    readonly preferences?: AutoscalingGroupInstanceRefreshPreferences[];
}
/**
 * @stability stable
 */
export interface AutoscalingGroupLaunchTemplate {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#id AutoscalingGroup#id}.
     *
     * @stability stable
     */
    readonly id?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#name AutoscalingGroup#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#version AutoscalingGroup#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyInstancesDistribution {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#on_demand_allocation_strategy AutoscalingGroup#on_demand_allocation_strategy}.
     *
     * @stability stable
     */
    readonly onDemandAllocationStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#on_demand_base_capacity AutoscalingGroup#on_demand_base_capacity}.
     *
     * @stability stable
     */
    readonly onDemandBaseCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#on_demand_percentage_above_base_capacity AutoscalingGroup#on_demand_percentage_above_base_capacity}.
     *
     * @stability stable
     */
    readonly onDemandPercentageAboveBaseCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#spot_allocation_strategy AutoscalingGroup#spot_allocation_strategy}.
     *
     * @stability stable
     */
    readonly spotAllocationStrategy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#spot_instance_pools AutoscalingGroup#spot_instance_pools}.
     *
     * @stability stable
     */
    readonly spotInstancePools?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#spot_max_price AutoscalingGroup#spot_max_price}.
     *
     * @stability stable
     */
    readonly spotMaxPrice?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#launch_template_id AutoscalingGroup#launch_template_id}.
     *
     * @stability stable
     */
    readonly launchTemplateId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#launch_template_name AutoscalingGroup#launch_template_name}.
     *
     * @stability stable
     */
    readonly launchTemplateName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#version AutoscalingGroup#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecification {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#launch_template_id AutoscalingGroup#launch_template_id}.
     *
     * @stability stable
     */
    readonly launchTemplateId?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#launch_template_name AutoscalingGroup#launch_template_name}.
     *
     * @stability stable
     */
    readonly launchTemplateName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#version AutoscalingGroup#version}.
     *
     * @stability stable
     */
    readonly version?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverride {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#instance_type AutoscalingGroup#instance_type}.
     *
     * @stability stable
     */
    readonly instanceType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#weighted_capacity AutoscalingGroup#weighted_capacity}.
     *
     * @stability stable
     */
    readonly weightedCapacity?: string;
    /**
     * launch_template_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#launch_template_specification AutoscalingGroup#launch_template_specification}
     *
     * @stability stable
     */
    readonly launchTemplateSpecification?: AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverrideLaunchTemplateSpecification[];
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicyLaunchTemplate {
    /**
     * launch_template_specification block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#launch_template_specification AutoscalingGroup#launch_template_specification}
     *
     * @stability stable
     */
    readonly launchTemplateSpecification: AutoscalingGroupMixedInstancesPolicyLaunchTemplateLaunchTemplateSpecification[];
    /**
     * override block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#override AutoscalingGroup#override}
     *
     * @stability stable
     */
    readonly override?: AutoscalingGroupMixedInstancesPolicyLaunchTemplateOverride[];
}
/**
 * @stability stable
 */
export interface AutoscalingGroupMixedInstancesPolicy {
    /**
     * instances_distribution block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#instances_distribution AutoscalingGroup#instances_distribution}
     *
     * @stability stable
     */
    readonly instancesDistribution?: AutoscalingGroupMixedInstancesPolicyInstancesDistribution[];
    /**
     * launch_template block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#launch_template AutoscalingGroup#launch_template}
     *
     * @stability stable
     */
    readonly launchTemplate: AutoscalingGroupMixedInstancesPolicyLaunchTemplate[];
}
/**
 * @stability stable
 */
export interface AutoscalingGroupTag {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#key AutoscalingGroup#key}.
     *
     * @stability stable
     */
    readonly key: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#propagate_at_launch AutoscalingGroup#propagate_at_launch}.
     *
     * @stability stable
     */
    readonly propagateAtLaunch: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#value AutoscalingGroup#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#delete AutoscalingGroup#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
}
/**
 * @stability stable
 */
export interface AutoscalingGroupWarmPool {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#max_group_prepared_capacity AutoscalingGroup#max_group_prepared_capacity}.
     *
     * @stability stable
     */
    readonly maxGroupPreparedCapacity?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#min_size AutoscalingGroup#min_size}.
     *
     * @stability stable
     */
    readonly minSize?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html#pool_state AutoscalingGroup#pool_state}.
     *
     * @stability stable
     */
    readonly poolState?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html aws_autoscaling_group}.
 *
 * @stability stable
 */
export declare class AutoscalingGroup extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/autoscaling_group.html aws_autoscaling_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: AutoscalingGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _availabilityZones?;
    /**
     * @stability stable
     */
    get availabilityZones(): string[];
    /**
     * @stability stable
     */
    set availabilityZones(value: string[]);
    /**
     * @stability stable
     */
    resetAvailabilityZones(): void;
    /**
     * @stability stable
     */
    get availabilityZonesInput(): string[] | undefined;
    private _capacityRebalance?;
    /**
     * @stability stable
     */
    get capacityRebalance(): boolean;
    /**
     * @stability stable
     */
    set capacityRebalance(value: boolean);
    /**
     * @stability stable
     */
    resetCapacityRebalance(): void;
    /**
     * @stability stable
     */
    get capacityRebalanceInput(): boolean | undefined;
    private _defaultCooldown?;
    /**
     * @stability stable
     */
    get defaultCooldown(): number;
    /**
     * @stability stable
     */
    set defaultCooldown(value: number);
    /**
     * @stability stable
     */
    resetDefaultCooldown(): void;
    /**
     * @stability stable
     */
    get defaultCooldownInput(): number | undefined;
    private _desiredCapacity?;
    /**
     * @stability stable
     */
    get desiredCapacity(): number;
    /**
     * @stability stable
     */
    set desiredCapacity(value: number);
    /**
     * @stability stable
     */
    resetDesiredCapacity(): void;
    /**
     * @stability stable
     */
    get desiredCapacityInput(): number | undefined;
    private _enabledMetrics?;
    /**
     * @stability stable
     */
    get enabledMetrics(): string[];
    /**
     * @stability stable
     */
    set enabledMetrics(value: string[]);
    /**
     * @stability stable
     */
    resetEnabledMetrics(): void;
    /**
     * @stability stable
     */
    get enabledMetricsInput(): string[] | undefined;
    private _forceDelete?;
    /**
     * @stability stable
     */
    get forceDelete(): boolean;
    /**
     * @stability stable
     */
    set forceDelete(value: boolean);
    /**
     * @stability stable
     */
    resetForceDelete(): void;
    /**
     * @stability stable
     */
    get forceDeleteInput(): boolean | undefined;
    private _forceDeleteWarmPool?;
    /**
     * @stability stable
     */
    get forceDeleteWarmPool(): boolean;
    /**
     * @stability stable
     */
    set forceDeleteWarmPool(value: boolean);
    /**
     * @stability stable
     */
    resetForceDeleteWarmPool(): void;
    /**
     * @stability stable
     */
    get forceDeleteWarmPoolInput(): boolean | undefined;
    private _healthCheckGracePeriod?;
    /**
     * @stability stable
     */
    get healthCheckGracePeriod(): number;
    /**
     * @stability stable
     */
    set healthCheckGracePeriod(value: number);
    /**
     * @stability stable
     */
    resetHealthCheckGracePeriod(): void;
    /**
     * @stability stable
     */
    get healthCheckGracePeriodInput(): number | undefined;
    private _healthCheckType?;
    /**
     * @stability stable
     */
    get healthCheckType(): string;
    /**
     * @stability stable
     */
    set healthCheckType(value: string);
    /**
     * @stability stable
     */
    resetHealthCheckType(): void;
    /**
     * @stability stable
     */
    get healthCheckTypeInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _launchConfiguration?;
    /**
     * @stability stable
     */
    get launchConfiguration(): string;
    /**
     * @stability stable
     */
    set launchConfiguration(value: string);
    /**
     * @stability stable
     */
    resetLaunchConfiguration(): void;
    /**
     * @stability stable
     */
    get launchConfigurationInput(): string | undefined;
    private _loadBalancers?;
    /**
     * @stability stable
     */
    get loadBalancers(): string[];
    /**
     * @stability stable
     */
    set loadBalancers(value: string[]);
    /**
     * @stability stable
     */
    resetLoadBalancers(): void;
    /**
     * @stability stable
     */
    get loadBalancersInput(): string[] | undefined;
    private _maxInstanceLifetime?;
    /**
     * @stability stable
     */
    get maxInstanceLifetime(): number;
    /**
     * @stability stable
     */
    set maxInstanceLifetime(value: number);
    /**
     * @stability stable
     */
    resetMaxInstanceLifetime(): void;
    /**
     * @stability stable
     */
    get maxInstanceLifetimeInput(): number | undefined;
    private _maxSize;
    /**
     * @stability stable
     */
    get maxSize(): number;
    /**
     * @stability stable
     */
    set maxSize(value: number);
    /**
     * @stability stable
     */
    get maxSizeInput(): number;
    private _metricsGranularity?;
    /**
     * @stability stable
     */
    get metricsGranularity(): string;
    /**
     * @stability stable
     */
    set metricsGranularity(value: string);
    /**
     * @stability stable
     */
    resetMetricsGranularity(): void;
    /**
     * @stability stable
     */
    get metricsGranularityInput(): string | undefined;
    private _minElbCapacity?;
    /**
     * @stability stable
     */
    get minElbCapacity(): number;
    /**
     * @stability stable
     */
    set minElbCapacity(value: number);
    /**
     * @stability stable
     */
    resetMinElbCapacity(): void;
    /**
     * @stability stable
     */
    get minElbCapacityInput(): number | undefined;
    private _minSize;
    /**
     * @stability stable
     */
    get minSize(): number;
    /**
     * @stability stable
     */
    set minSize(value: number);
    /**
     * @stability stable
     */
    get minSizeInput(): number;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _placementGroup?;
    /**
     * @stability stable
     */
    get placementGroup(): string;
    /**
     * @stability stable
     */
    set placementGroup(value: string);
    /**
     * @stability stable
     */
    resetPlacementGroup(): void;
    /**
     * @stability stable
     */
    get placementGroupInput(): string | undefined;
    private _protectFromScaleIn?;
    /**
     * @stability stable
     */
    get protectFromScaleIn(): boolean;
    /**
     * @stability stable
     */
    set protectFromScaleIn(value: boolean);
    /**
     * @stability stable
     */
    resetProtectFromScaleIn(): void;
    /**
     * @stability stable
     */
    get protectFromScaleInInput(): boolean | undefined;
    private _serviceLinkedRoleArn?;
    /**
     * @stability stable
     */
    get serviceLinkedRoleArn(): string;
    /**
     * @stability stable
     */
    set serviceLinkedRoleArn(value: string);
    /**
     * @stability stable
     */
    resetServiceLinkedRoleArn(): void;
    /**
     * @stability stable
     */
    get serviceLinkedRoleArnInput(): string | undefined;
    private _suspendedProcesses?;
    /**
     * @stability stable
     */
    get suspendedProcesses(): string[];
    /**
     * @stability stable
     */
    set suspendedProcesses(value: string[]);
    /**
     * @stability stable
     */
    resetSuspendedProcesses(): void;
    /**
     * @stability stable
     */
    get suspendedProcessesInput(): string[] | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _targetGroupArns?;
    /**
     * @stability stable
     */
    get targetGroupArns(): string[];
    /**
     * @stability stable
     */
    set targetGroupArns(value: string[]);
    /**
     * @stability stable
     */
    resetTargetGroupArns(): void;
    /**
     * @stability stable
     */
    get targetGroupArnsInput(): string[] | undefined;
    private _terminationPolicies?;
    /**
     * @stability stable
     */
    get terminationPolicies(): string[];
    /**
     * @stability stable
     */
    set terminationPolicies(value: string[]);
    /**
     * @stability stable
     */
    resetTerminationPolicies(): void;
    /**
     * @stability stable
     */
    get terminationPoliciesInput(): string[] | undefined;
    private _vpcZoneIdentifier?;
    /**
     * @stability stable
     */
    get vpcZoneIdentifier(): string[];
    /**
     * @stability stable
     */
    set vpcZoneIdentifier(value: string[]);
    /**
     * @stability stable
     */
    resetVpcZoneIdentifier(): void;
    /**
     * @stability stable
     */
    get vpcZoneIdentifierInput(): string[] | undefined;
    private _waitForCapacityTimeout?;
    /**
     * @stability stable
     */
    get waitForCapacityTimeout(): string;
    /**
     * @stability stable
     */
    set waitForCapacityTimeout(value: string);
    /**
     * @stability stable
     */
    resetWaitForCapacityTimeout(): void;
    /**
     * @stability stable
     */
    get waitForCapacityTimeoutInput(): string | undefined;
    private _waitForElbCapacity?;
    /**
     * @stability stable
     */
    get waitForElbCapacity(): number;
    /**
     * @stability stable
     */
    set waitForElbCapacity(value: number);
    /**
     * @stability stable
     */
    resetWaitForElbCapacity(): void;
    /**
     * @stability stable
     */
    get waitForElbCapacityInput(): number | undefined;
    private _initialLifecycleHook?;
    /**
     * @stability stable
     */
    get initialLifecycleHook(): AutoscalingGroupInitialLifecycleHook[];
    /**
     * @stability stable
     */
    set initialLifecycleHook(value: AutoscalingGroupInitialLifecycleHook[]);
    /**
     * @stability stable
     */
    resetInitialLifecycleHook(): void;
    /**
     * @stability stable
     */
    get initialLifecycleHookInput(): AutoscalingGroupInitialLifecycleHook[] | undefined;
    private _instanceRefresh?;
    /**
     * @stability stable
     */
    get instanceRefresh(): AutoscalingGroupInstanceRefresh[];
    /**
     * @stability stable
     */
    set instanceRefresh(value: AutoscalingGroupInstanceRefresh[]);
    /**
     * @stability stable
     */
    resetInstanceRefresh(): void;
    /**
     * @stability stable
     */
    get instanceRefreshInput(): AutoscalingGroupInstanceRefresh[] | undefined;
    private _launchTemplate?;
    /**
     * @stability stable
     */
    get launchTemplate(): AutoscalingGroupLaunchTemplate[];
    /**
     * @stability stable
     */
    set launchTemplate(value: AutoscalingGroupLaunchTemplate[]);
    /**
     * @stability stable
     */
    resetLaunchTemplate(): void;
    /**
     * @stability stable
     */
    get launchTemplateInput(): AutoscalingGroupLaunchTemplate[] | undefined;
    private _mixedInstancesPolicy?;
    /**
     * @stability stable
     */
    get mixedInstancesPolicy(): AutoscalingGroupMixedInstancesPolicy[];
    /**
     * @stability stable
     */
    set mixedInstancesPolicy(value: AutoscalingGroupMixedInstancesPolicy[]);
    /**
     * @stability stable
     */
    resetMixedInstancesPolicy(): void;
    /**
     * @stability stable
     */
    get mixedInstancesPolicyInput(): AutoscalingGroupMixedInstancesPolicy[] | undefined;
    private _tag?;
    /**
     * @stability stable
     */
    get tag(): AutoscalingGroupTag[];
    /**
     * @stability stable
     */
    set tag(value: AutoscalingGroupTag[]);
    /**
     * @stability stable
     */
    resetTag(): void;
    /**
     * @stability stable
     */
    get tagInput(): AutoscalingGroupTag[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): AutoscalingGroupTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: AutoscalingGroupTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): AutoscalingGroupTimeouts | undefined;
    private _warmPool?;
    /**
     * @stability stable
     */
    get warmPool(): AutoscalingGroupWarmPool[];
    /**
     * @stability stable
     */
    set warmPool(value: AutoscalingGroupWarmPool[]);
    /**
     * @stability stable
     */
    resetWarmPool(): void;
    /**
     * @stability stable
     */
    get warmPoolInput(): AutoscalingGroupWarmPool[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
