import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface CloudwatchLogDestinationPolicyConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination_policy.html#access_policy CloudwatchLogDestinationPolicy#access_policy}.
     *
     * @stability stable
     */
    readonly accessPolicy: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination_policy.html#destination_name CloudwatchLogDestinationPolicy#destination_name}.
     *
     * @stability stable
     */
    readonly destinationName: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination_policy.html aws_cloudwatch_log_destination_policy}.
 *
 * @stability stable
 */
export declare class CloudwatchLogDestinationPolicy extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/cloudwatch_log_destination_policy.html aws_cloudwatch_log_destination_policy} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: CloudwatchLogDestinationPolicyConfig);
    private _accessPolicy;
    /**
     * @stability stable
     */
    get accessPolicy(): string;
    /**
     * @stability stable
     */
    set accessPolicy(value: string);
    /**
     * @stability stable
     */
    get accessPolicyInput(): string;
    private _destinationName;
    /**
     * @stability stable
     */
    get destinationName(): string;
    /**
     * @stability stable
     */
    set destinationName(value: string);
    /**
     * @stability stable
     */
    get destinationNameInput(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
