import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsLaunchConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/launch_configuration.html#name DataAwsLaunchConfiguration#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchConfigurationEbsBlockDevice extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deleteOnTermination(): boolean;
    /**
     * @stability stable
     */
    get deviceName(): string;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    get noDevice(): boolean;
    /**
     * @stability stable
     */
    get snapshotId(): string;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    /**
     * @stability stable
     */
    get volumeType(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchConfigurationEphemeralBlockDevice extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deviceName(): string;
    /**
     * @stability stable
     */
    get virtualName(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchConfigurationMetadataOptions extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get httpEndpoint(): string;
    /**
     * @stability stable
     */
    get httpPutResponseHopLimit(): number;
    /**
     * @stability stable
     */
    get httpTokens(): string;
}
/**
 * @stability stable
 */
export declare class DataAwsLaunchConfigurationRootBlockDevice extends cdktf.ComplexComputedList {
    /**
     * @stability stable
     */
    get deleteOnTermination(): boolean;
    /**
     * @stability stable
     */
    get encrypted(): boolean;
    /**
     * @stability stable
     */
    get iops(): number;
    /**
     * @stability stable
     */
    get volumeSize(): number;
    /**
     * @stability stable
     */
    get volumeType(): string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/launch_configuration.html aws_launch_configuration}.
 *
 * @stability stable
 */
export declare class DataAwsLaunchConfiguration extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/launch_configuration.html aws_launch_configuration} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsLaunchConfigurationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get associatePublicIpAddress(): boolean;
    /**
     * @stability stable
     */
    ebsBlockDevice(index: string): DataAwsLaunchConfigurationEbsBlockDevice;
    /**
     * @stability stable
     */
    get ebsOptimized(): boolean;
    /**
     * @stability stable
     */
    get enableMonitoring(): boolean;
    /**
     * @stability stable
     */
    ephemeralBlockDevice(index: string): DataAwsLaunchConfigurationEphemeralBlockDevice;
    /**
     * @stability stable
     */
    get iamInstanceProfile(): string;
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get imageId(): string;
    /**
     * @stability stable
     */
    get instanceType(): string;
    /**
     * @stability stable
     */
    get keyName(): string;
    /**
     * @stability stable
     */
    metadataOptions(index: string): DataAwsLaunchConfigurationMetadataOptions;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    /**
     * @stability stable
     */
    get placementTenancy(): string;
    /**
     * @stability stable
     */
    rootBlockDevice(index: string): DataAwsLaunchConfigurationRootBlockDevice;
    /**
     * @stability stable
     */
    get securityGroups(): string[];
    /**
     * @stability stable
     */
    get spotPrice(): string;
    /**
     * @stability stable
     */
    get userData(): string;
    /**
     * @stability stable
     */
    get vpcClassicLinkId(): string;
    /**
     * @stability stable
     */
    get vpcClassicLinkSecurityGroups(): string[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
