import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface DataAwsPricingProductConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/pricing_product.html#service_code DataAwsPricingProduct#service_code}.
     *
     * @stability stable
     */
    readonly serviceCode: string;
    /**
     * filters block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/pricing_product.html#filters DataAwsPricingProduct#filters}
     *
     * @stability stable
     */
    readonly filters: DataAwsPricingProductFilters[];
}
/**
 * @stability stable
 */
export interface DataAwsPricingProductFilters {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/pricing_product.html#field DataAwsPricingProduct#field}.
     *
     * @stability stable
     */
    readonly field: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/d/pricing_product.html#value DataAwsPricingProduct#value}.
     *
     * @stability stable
     */
    readonly value: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/d/pricing_product.html aws_pricing_product}.
 *
 * @stability stable
 */
export declare class DataAwsPricingProduct extends cdktf.TerraformDataSource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/d/pricing_product.html aws_pricing_product} Data Source.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: DataAwsPricingProductConfig);
    /**
     * @stability stable
     */
    get id(): string;
    /**
     * @stability stable
     */
    get result(): string;
    private _serviceCode;
    /**
     * @stability stable
     */
    get serviceCode(): string;
    /**
     * @stability stable
     */
    set serviceCode(value: string);
    /**
     * @stability stable
     */
    get serviceCodeInput(): string;
    private _filters;
    /**
     * @stability stable
     */
    get filters(): DataAwsPricingProductFilters[];
    /**
     * @stability stable
     */
    set filters(value: DataAwsPricingProductFilters[]);
    /**
     * @stability stable
     */
    get filtersInput(): DataAwsPricingProductFilters[];
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
