import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface IotThingTypeConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_type.html#deprecated IotThingType#deprecated}.
     *
     * @stability stable
     */
    readonly deprecated?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_type.html#name IotThingType#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * properties block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_type.html#properties IotThingType#properties}
     *
     * @stability stable
     */
    readonly properties?: IotThingTypeProperties[];
}
/**
 * @stability stable
 */
export interface IotThingTypeProperties {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_type.html#description IotThingType#description}.
     *
     * @stability stable
     */
    readonly description?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_type.html#searchable_attributes IotThingType#searchable_attributes}.
     *
     * @stability stable
     */
    readonly searchableAttributes?: string[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_type.html aws_iot_thing_type}.
 *
 * @stability stable
 */
export declare class IotThingType extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/iot_thing_type.html aws_iot_thing_type} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: IotThingTypeConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _deprecated?;
    /**
     * @stability stable
     */
    get deprecated(): boolean;
    /**
     * @stability stable
     */
    set deprecated(value: boolean);
    /**
     * @stability stable
     */
    resetDeprecated(): void;
    /**
     * @stability stable
     */
    get deprecatedInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _properties?;
    /**
     * @stability stable
     */
    get properties(): IotThingTypeProperties[];
    /**
     * @stability stable
     */
    set properties(value: IotThingTypeProperties[]);
    /**
     * @stability stable
     */
    resetProperties(): void;
    /**
     * @stability stable
     */
    get propertiesInput(): IotThingTypeProperties[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
