import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface LbTargetGroupConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#deregistration_delay LbTargetGroup#deregistration_delay}.
     *
     * @stability stable
     */
    readonly deregistrationDelay?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#lambda_multi_value_headers_enabled LbTargetGroup#lambda_multi_value_headers_enabled}.
     *
     * @stability stable
     */
    readonly lambdaMultiValueHeadersEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#load_balancing_algorithm_type LbTargetGroup#load_balancing_algorithm_type}.
     *
     * @stability stable
     */
    readonly loadBalancingAlgorithmType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#name LbTargetGroup#name}.
     *
     * @stability stable
     */
    readonly name?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#name_prefix LbTargetGroup#name_prefix}.
     *
     * @stability stable
     */
    readonly namePrefix?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#port LbTargetGroup#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#preserve_client_ip LbTargetGroup#preserve_client_ip}.
     *
     * @stability stable
     */
    readonly preserveClientIp?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#protocol LbTargetGroup#protocol}.
     *
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#protocol_version LbTargetGroup#protocol_version}.
     *
     * @stability stable
     */
    readonly protocolVersion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#proxy_protocol_v2 LbTargetGroup#proxy_protocol_v2}.
     *
     * @stability stable
     */
    readonly proxyProtocolV2?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#slow_start LbTargetGroup#slow_start}.
     *
     * @stability stable
     */
    readonly slowStart?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#tags LbTargetGroup#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#tags_all LbTargetGroup#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#target_type LbTargetGroup#target_type}.
     *
     * @stability stable
     */
    readonly targetType?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#vpc_id LbTargetGroup#vpc_id}.
     *
     * @stability stable
     */
    readonly vpcId?: string;
    /**
     * health_check block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#health_check LbTargetGroup#health_check}
     *
     * @stability stable
     */
    readonly healthCheck?: LbTargetGroupHealthCheck[];
    /**
     * stickiness block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#stickiness LbTargetGroup#stickiness}
     *
     * @stability stable
     */
    readonly stickiness?: LbTargetGroupStickiness[];
}
/**
 * @stability stable
 */
export interface LbTargetGroupHealthCheck {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#enabled LbTargetGroup#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#healthy_threshold LbTargetGroup#healthy_threshold}.
     *
     * @stability stable
     */
    readonly healthyThreshold?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#interval LbTargetGroup#interval}.
     *
     * @stability stable
     */
    readonly interval?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#matcher LbTargetGroup#matcher}.
     *
     * @stability stable
     */
    readonly matcher?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#path LbTargetGroup#path}.
     *
     * @stability stable
     */
    readonly path?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#port LbTargetGroup#port}.
     *
     * @stability stable
     */
    readonly port?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#protocol LbTargetGroup#protocol}.
     *
     * @stability stable
     */
    readonly protocol?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#timeout LbTargetGroup#timeout}.
     *
     * @stability stable
     */
    readonly timeout?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#unhealthy_threshold LbTargetGroup#unhealthy_threshold}.
     *
     * @stability stable
     */
    readonly unhealthyThreshold?: number;
}
/**
 * @stability stable
 */
export interface LbTargetGroupStickiness {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#cookie_duration LbTargetGroup#cookie_duration}.
     *
     * @stability stable
     */
    readonly cookieDuration?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#enabled LbTargetGroup#enabled}.
     *
     * @stability stable
     */
    readonly enabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html#type LbTargetGroup#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html aws_lb_target_group}.
 *
 * @stability stable
 */
export declare class LbTargetGroup extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/lb_target_group.html aws_lb_target_group} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config?: LbTargetGroupConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    /**
     * @stability stable
     */
    get arnSuffix(): string;
    private _deregistrationDelay?;
    /**
     * @stability stable
     */
    get deregistrationDelay(): number;
    /**
     * @stability stable
     */
    set deregistrationDelay(value: number);
    /**
     * @stability stable
     */
    resetDeregistrationDelay(): void;
    /**
     * @stability stable
     */
    get deregistrationDelayInput(): number | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _lambdaMultiValueHeadersEnabled?;
    /**
     * @stability stable
     */
    get lambdaMultiValueHeadersEnabled(): boolean;
    /**
     * @stability stable
     */
    set lambdaMultiValueHeadersEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetLambdaMultiValueHeadersEnabled(): void;
    /**
     * @stability stable
     */
    get lambdaMultiValueHeadersEnabledInput(): boolean | undefined;
    private _loadBalancingAlgorithmType?;
    /**
     * @stability stable
     */
    get loadBalancingAlgorithmType(): string;
    /**
     * @stability stable
     */
    set loadBalancingAlgorithmType(value: string);
    /**
     * @stability stable
     */
    resetLoadBalancingAlgorithmType(): void;
    /**
     * @stability stable
     */
    get loadBalancingAlgorithmTypeInput(): string | undefined;
    private _name?;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    resetName(): void;
    /**
     * @stability stable
     */
    get nameInput(): string | undefined;
    private _namePrefix?;
    /**
     * @stability stable
     */
    get namePrefix(): string;
    /**
     * @stability stable
     */
    set namePrefix(value: string);
    /**
     * @stability stable
     */
    resetNamePrefix(): void;
    /**
     * @stability stable
     */
    get namePrefixInput(): string | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _preserveClientIp?;
    /**
     * @stability stable
     */
    get preserveClientIp(): string;
    /**
     * @stability stable
     */
    set preserveClientIp(value: string);
    /**
     * @stability stable
     */
    resetPreserveClientIp(): void;
    /**
     * @stability stable
     */
    get preserveClientIpInput(): string | undefined;
    private _protocol?;
    /**
     * @stability stable
     */
    get protocol(): string;
    /**
     * @stability stable
     */
    set protocol(value: string);
    /**
     * @stability stable
     */
    resetProtocol(): void;
    /**
     * @stability stable
     */
    get protocolInput(): string | undefined;
    private _protocolVersion?;
    /**
     * @stability stable
     */
    get protocolVersion(): string;
    /**
     * @stability stable
     */
    set protocolVersion(value: string);
    /**
     * @stability stable
     */
    resetProtocolVersion(): void;
    /**
     * @stability stable
     */
    get protocolVersionInput(): string | undefined;
    private _proxyProtocolV2?;
    /**
     * @stability stable
     */
    get proxyProtocolV2(): boolean;
    /**
     * @stability stable
     */
    set proxyProtocolV2(value: boolean);
    /**
     * @stability stable
     */
    resetProxyProtocolV2(): void;
    /**
     * @stability stable
     */
    get proxyProtocolV2Input(): boolean | undefined;
    private _slowStart?;
    /**
     * @stability stable
     */
    get slowStart(): number;
    /**
     * @stability stable
     */
    set slowStart(value: number);
    /**
     * @stability stable
     */
    resetSlowStart(): void;
    /**
     * @stability stable
     */
    get slowStartInput(): number | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _targetType?;
    /**
     * @stability stable
     */
    get targetType(): string;
    /**
     * @stability stable
     */
    set targetType(value: string);
    /**
     * @stability stable
     */
    resetTargetType(): void;
    /**
     * @stability stable
     */
    get targetTypeInput(): string | undefined;
    private _vpcId?;
    /**
     * @stability stable
     */
    get vpcId(): string;
    /**
     * @stability stable
     */
    set vpcId(value: string);
    /**
     * @stability stable
     */
    resetVpcId(): void;
    /**
     * @stability stable
     */
    get vpcIdInput(): string | undefined;
    private _healthCheck?;
    /**
     * @stability stable
     */
    get healthCheck(): LbTargetGroupHealthCheck[];
    /**
     * @stability stable
     */
    set healthCheck(value: LbTargetGroupHealthCheck[]);
    /**
     * @stability stable
     */
    resetHealthCheck(): void;
    /**
     * @stability stable
     */
    get healthCheckInput(): LbTargetGroupHealthCheck[] | undefined;
    private _stickiness?;
    /**
     * @stability stable
     */
    get stickiness(): LbTargetGroupStickiness[];
    /**
     * @stability stable
     */
    set stickiness(value: LbTargetGroupStickiness[]);
    /**
     * @stability stable
     */
    resetStickiness(): void;
    /**
     * @stability stable
     */
    get stickinessInput(): LbTargetGroupStickiness[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
