import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Route53HealthCheckConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#child_health_threshold Route53HealthCheck#child_health_threshold}.
     *
     * @stability stable
     */
    readonly childHealthThreshold?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#child_healthchecks Route53HealthCheck#child_healthchecks}.
     *
     * @stability stable
     */
    readonly childHealthchecks?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#cloudwatch_alarm_name Route53HealthCheck#cloudwatch_alarm_name}.
     *
     * @stability stable
     */
    readonly cloudwatchAlarmName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#cloudwatch_alarm_region Route53HealthCheck#cloudwatch_alarm_region}.
     *
     * @stability stable
     */
    readonly cloudwatchAlarmRegion?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#disabled Route53HealthCheck#disabled}.
     *
     * @stability stable
     */
    readonly disabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#enable_sni Route53HealthCheck#enable_sni}.
     *
     * @stability stable
     */
    readonly enableSni?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#failure_threshold Route53HealthCheck#failure_threshold}.
     *
     * @stability stable
     */
    readonly failureThreshold?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#fqdn Route53HealthCheck#fqdn}.
     *
     * @stability stable
     */
    readonly fqdn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#insufficient_data_health_status Route53HealthCheck#insufficient_data_health_status}.
     *
     * @stability stable
     */
    readonly insufficientDataHealthStatus?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#invert_healthcheck Route53HealthCheck#invert_healthcheck}.
     *
     * @stability stable
     */
    readonly invertHealthcheck?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#ip_address Route53HealthCheck#ip_address}.
     *
     * @stability stable
     */
    readonly ipAddress?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#measure_latency Route53HealthCheck#measure_latency}.
     *
     * @stability stable
     */
    readonly measureLatency?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#port Route53HealthCheck#port}.
     *
     * @stability stable
     */
    readonly port?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#reference_name Route53HealthCheck#reference_name}.
     *
     * @stability stable
     */
    readonly referenceName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#regions Route53HealthCheck#regions}.
     *
     * @stability stable
     */
    readonly regions?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#request_interval Route53HealthCheck#request_interval}.
     *
     * @stability stable
     */
    readonly requestInterval?: number;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#resource_path Route53HealthCheck#resource_path}.
     *
     * @stability stable
     */
    readonly resourcePath?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#search_string Route53HealthCheck#search_string}.
     *
     * @stability stable
     */
    readonly searchString?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#tags Route53HealthCheck#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#tags_all Route53HealthCheck#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html#type Route53HealthCheck#type}.
     *
     * @stability stable
     */
    readonly type: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html aws_route53_health_check}.
 *
 * @stability stable
 */
export declare class Route53HealthCheck extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/route53_health_check.html aws_route53_health_check} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Route53HealthCheckConfig);
    private _childHealthThreshold?;
    /**
     * @stability stable
     */
    get childHealthThreshold(): number;
    /**
     * @stability stable
     */
    set childHealthThreshold(value: number);
    /**
     * @stability stable
     */
    resetChildHealthThreshold(): void;
    /**
     * @stability stable
     */
    get childHealthThresholdInput(): number | undefined;
    private _childHealthchecks?;
    /**
     * @stability stable
     */
    get childHealthchecks(): string[];
    /**
     * @stability stable
     */
    set childHealthchecks(value: string[]);
    /**
     * @stability stable
     */
    resetChildHealthchecks(): void;
    /**
     * @stability stable
     */
    get childHealthchecksInput(): string[] | undefined;
    private _cloudwatchAlarmName?;
    /**
     * @stability stable
     */
    get cloudwatchAlarmName(): string;
    /**
     * @stability stable
     */
    set cloudwatchAlarmName(value: string);
    /**
     * @stability stable
     */
    resetCloudwatchAlarmName(): void;
    /**
     * @stability stable
     */
    get cloudwatchAlarmNameInput(): string | undefined;
    private _cloudwatchAlarmRegion?;
    /**
     * @stability stable
     */
    get cloudwatchAlarmRegion(): string;
    /**
     * @stability stable
     */
    set cloudwatchAlarmRegion(value: string);
    /**
     * @stability stable
     */
    resetCloudwatchAlarmRegion(): void;
    /**
     * @stability stable
     */
    get cloudwatchAlarmRegionInput(): string | undefined;
    private _disabled?;
    /**
     * @stability stable
     */
    get disabled(): boolean;
    /**
     * @stability stable
     */
    set disabled(value: boolean);
    /**
     * @stability stable
     */
    resetDisabled(): void;
    /**
     * @stability stable
     */
    get disabledInput(): boolean | undefined;
    private _enableSni?;
    /**
     * @stability stable
     */
    get enableSni(): boolean;
    /**
     * @stability stable
     */
    set enableSni(value: boolean);
    /**
     * @stability stable
     */
    resetEnableSni(): void;
    /**
     * @stability stable
     */
    get enableSniInput(): boolean | undefined;
    private _failureThreshold?;
    /**
     * @stability stable
     */
    get failureThreshold(): number;
    /**
     * @stability stable
     */
    set failureThreshold(value: number);
    /**
     * @stability stable
     */
    resetFailureThreshold(): void;
    /**
     * @stability stable
     */
    get failureThresholdInput(): number | undefined;
    private _fqdn?;
    /**
     * @stability stable
     */
    get fqdn(): string;
    /**
     * @stability stable
     */
    set fqdn(value: string);
    /**
     * @stability stable
     */
    resetFqdn(): void;
    /**
     * @stability stable
     */
    get fqdnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _insufficientDataHealthStatus?;
    /**
     * @stability stable
     */
    get insufficientDataHealthStatus(): string;
    /**
     * @stability stable
     */
    set insufficientDataHealthStatus(value: string);
    /**
     * @stability stable
     */
    resetInsufficientDataHealthStatus(): void;
    /**
     * @stability stable
     */
    get insufficientDataHealthStatusInput(): string | undefined;
    private _invertHealthcheck?;
    /**
     * @stability stable
     */
    get invertHealthcheck(): boolean;
    /**
     * @stability stable
     */
    set invertHealthcheck(value: boolean);
    /**
     * @stability stable
     */
    resetInvertHealthcheck(): void;
    /**
     * @stability stable
     */
    get invertHealthcheckInput(): boolean | undefined;
    private _ipAddress?;
    /**
     * @stability stable
     */
    get ipAddress(): string;
    /**
     * @stability stable
     */
    set ipAddress(value: string);
    /**
     * @stability stable
     */
    resetIpAddress(): void;
    /**
     * @stability stable
     */
    get ipAddressInput(): string | undefined;
    private _measureLatency?;
    /**
     * @stability stable
     */
    get measureLatency(): boolean;
    /**
     * @stability stable
     */
    set measureLatency(value: boolean);
    /**
     * @stability stable
     */
    resetMeasureLatency(): void;
    /**
     * @stability stable
     */
    get measureLatencyInput(): boolean | undefined;
    private _port?;
    /**
     * @stability stable
     */
    get port(): number;
    /**
     * @stability stable
     */
    set port(value: number);
    /**
     * @stability stable
     */
    resetPort(): void;
    /**
     * @stability stable
     */
    get portInput(): number | undefined;
    private _referenceName?;
    /**
     * @stability stable
     */
    get referenceName(): string;
    /**
     * @stability stable
     */
    set referenceName(value: string);
    /**
     * @stability stable
     */
    resetReferenceName(): void;
    /**
     * @stability stable
     */
    get referenceNameInput(): string | undefined;
    private _regions?;
    /**
     * @stability stable
     */
    get regions(): string[];
    /**
     * @stability stable
     */
    set regions(value: string[]);
    /**
     * @stability stable
     */
    resetRegions(): void;
    /**
     * @stability stable
     */
    get regionsInput(): string[] | undefined;
    private _requestInterval?;
    /**
     * @stability stable
     */
    get requestInterval(): number;
    /**
     * @stability stable
     */
    set requestInterval(value: number);
    /**
     * @stability stable
     */
    resetRequestInterval(): void;
    /**
     * @stability stable
     */
    get requestIntervalInput(): number | undefined;
    private _resourcePath?;
    /**
     * @stability stable
     */
    get resourcePath(): string;
    /**
     * @stability stable
     */
    set resourcePath(value: string);
    /**
     * @stability stable
     */
    resetResourcePath(): void;
    /**
     * @stability stable
     */
    get resourcePathInput(): string | undefined;
    private _searchString?;
    /**
     * @stability stable
     */
    get searchString(): string;
    /**
     * @stability stable
     */
    set searchString(value: string);
    /**
     * @stability stable
     */
    resetSearchString(): void;
    /**
     * @stability stable
     */
    get searchStringInput(): string | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _type;
    /**
     * @stability stable
     */
    get type(): string;
    /**
     * @stability stable
     */
    set type(value: string);
    /**
     * @stability stable
     */
    get typeInput(): string;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
