import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface SnsPlatformApplicationConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#event_delivery_failure_topic_arn SnsPlatformApplication#event_delivery_failure_topic_arn}.
     *
     * @stability stable
     */
    readonly eventDeliveryFailureTopicArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#event_endpoint_created_topic_arn SnsPlatformApplication#event_endpoint_created_topic_arn}.
     *
     * @stability stable
     */
    readonly eventEndpointCreatedTopicArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#event_endpoint_deleted_topic_arn SnsPlatformApplication#event_endpoint_deleted_topic_arn}.
     *
     * @stability stable
     */
    readonly eventEndpointDeletedTopicArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#event_endpoint_updated_topic_arn SnsPlatformApplication#event_endpoint_updated_topic_arn}.
     *
     * @stability stable
     */
    readonly eventEndpointUpdatedTopicArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#failure_feedback_role_arn SnsPlatformApplication#failure_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly failureFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#name SnsPlatformApplication#name}.
     *
     * @stability stable
     */
    readonly name: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#platform SnsPlatformApplication#platform}.
     *
     * @stability stable
     */
    readonly platform: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#platform_credential SnsPlatformApplication#platform_credential}.
     *
     * @stability stable
     */
    readonly platformCredential: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#platform_principal SnsPlatformApplication#platform_principal}.
     *
     * @stability stable
     */
    readonly platformPrincipal?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#success_feedback_role_arn SnsPlatformApplication#success_feedback_role_arn}.
     *
     * @stability stable
     */
    readonly successFeedbackRoleArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html#success_feedback_sample_rate SnsPlatformApplication#success_feedback_sample_rate}.
     *
     * @stability stable
     */
    readonly successFeedbackSampleRate?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html aws_sns_platform_application}.
 *
 * @stability stable
 */
export declare class SnsPlatformApplication extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/sns_platform_application.html aws_sns_platform_application} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: SnsPlatformApplicationConfig);
    /**
     * @stability stable
     */
    get arn(): string;
    private _eventDeliveryFailureTopicArn?;
    /**
     * @stability stable
     */
    get eventDeliveryFailureTopicArn(): string;
    /**
     * @stability stable
     */
    set eventDeliveryFailureTopicArn(value: string);
    /**
     * @stability stable
     */
    resetEventDeliveryFailureTopicArn(): void;
    /**
     * @stability stable
     */
    get eventDeliveryFailureTopicArnInput(): string | undefined;
    private _eventEndpointCreatedTopicArn?;
    /**
     * @stability stable
     */
    get eventEndpointCreatedTopicArn(): string;
    /**
     * @stability stable
     */
    set eventEndpointCreatedTopicArn(value: string);
    /**
     * @stability stable
     */
    resetEventEndpointCreatedTopicArn(): void;
    /**
     * @stability stable
     */
    get eventEndpointCreatedTopicArnInput(): string | undefined;
    private _eventEndpointDeletedTopicArn?;
    /**
     * @stability stable
     */
    get eventEndpointDeletedTopicArn(): string;
    /**
     * @stability stable
     */
    set eventEndpointDeletedTopicArn(value: string);
    /**
     * @stability stable
     */
    resetEventEndpointDeletedTopicArn(): void;
    /**
     * @stability stable
     */
    get eventEndpointDeletedTopicArnInput(): string | undefined;
    private _eventEndpointUpdatedTopicArn?;
    /**
     * @stability stable
     */
    get eventEndpointUpdatedTopicArn(): string;
    /**
     * @stability stable
     */
    set eventEndpointUpdatedTopicArn(value: string);
    /**
     * @stability stable
     */
    resetEventEndpointUpdatedTopicArn(): void;
    /**
     * @stability stable
     */
    get eventEndpointUpdatedTopicArnInput(): string | undefined;
    private _failureFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get failureFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set failureFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetFailureFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get failureFeedbackRoleArnInput(): string | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _name;
    /**
     * @stability stable
     */
    get name(): string;
    /**
     * @stability stable
     */
    set name(value: string);
    /**
     * @stability stable
     */
    get nameInput(): string;
    private _platform;
    /**
     * @stability stable
     */
    get platform(): string;
    /**
     * @stability stable
     */
    set platform(value: string);
    /**
     * @stability stable
     */
    get platformInput(): string;
    private _platformCredential;
    /**
     * @stability stable
     */
    get platformCredential(): string;
    /**
     * @stability stable
     */
    set platformCredential(value: string);
    /**
     * @stability stable
     */
    get platformCredentialInput(): string;
    private _platformPrincipal?;
    /**
     * @stability stable
     */
    get platformPrincipal(): string;
    /**
     * @stability stable
     */
    set platformPrincipal(value: string);
    /**
     * @stability stable
     */
    resetPlatformPrincipal(): void;
    /**
     * @stability stable
     */
    get platformPrincipalInput(): string | undefined;
    private _successFeedbackRoleArn?;
    /**
     * @stability stable
     */
    get successFeedbackRoleArn(): string;
    /**
     * @stability stable
     */
    set successFeedbackRoleArn(value: string);
    /**
     * @stability stable
     */
    resetSuccessFeedbackRoleArn(): void;
    /**
     * @stability stable
     */
    get successFeedbackRoleArnInput(): string | undefined;
    private _successFeedbackSampleRate?;
    /**
     * @stability stable
     */
    get successFeedbackSampleRate(): string;
    /**
     * @stability stable
     */
    set successFeedbackSampleRate(value: string);
    /**
     * @stability stable
     */
    resetSuccessFeedbackSampleRate(): void;
    /**
     * @stability stable
     */
    get successFeedbackSampleRateInput(): string | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
