import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface StoragegatewaySmbFileShareConfig extends cdktf.TerraformMetaArguments {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#access_based_enumeration StoragegatewaySmbFileShare#access_based_enumeration}.
     *
     * @stability stable
     */
    readonly accessBasedEnumeration?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#admin_user_list StoragegatewaySmbFileShare#admin_user_list}.
     *
     * @stability stable
     */
    readonly adminUserList?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#audit_destination_arn StoragegatewaySmbFileShare#audit_destination_arn}.
     *
     * @stability stable
     */
    readonly auditDestinationArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#authentication StoragegatewaySmbFileShare#authentication}.
     *
     * @stability stable
     */
    readonly authentication?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#case_sensitivity StoragegatewaySmbFileShare#case_sensitivity}.
     *
     * @stability stable
     */
    readonly caseSensitivity?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#default_storage_class StoragegatewaySmbFileShare#default_storage_class}.
     *
     * @stability stable
     */
    readonly defaultStorageClass?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#file_share_name StoragegatewaySmbFileShare#file_share_name}.
     *
     * @stability stable
     */
    readonly fileShareName?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#gateway_arn StoragegatewaySmbFileShare#gateway_arn}.
     *
     * @stability stable
     */
    readonly gatewayArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#guess_mime_type_enabled StoragegatewaySmbFileShare#guess_mime_type_enabled}.
     *
     * @stability stable
     */
    readonly guessMimeTypeEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#invalid_user_list StoragegatewaySmbFileShare#invalid_user_list}.
     *
     * @stability stable
     */
    readonly invalidUserList?: string[];
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#kms_encrypted StoragegatewaySmbFileShare#kms_encrypted}.
     *
     * @stability stable
     */
    readonly kmsEncrypted?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#kms_key_arn StoragegatewaySmbFileShare#kms_key_arn}.
     *
     * @stability stable
     */
    readonly kmsKeyArn?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#location_arn StoragegatewaySmbFileShare#location_arn}.
     *
     * @stability stable
     */
    readonly locationArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#notification_policy StoragegatewaySmbFileShare#notification_policy}.
     *
     * @stability stable
     */
    readonly notificationPolicy?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#object_acl StoragegatewaySmbFileShare#object_acl}.
     *
     * @stability stable
     */
    readonly objectAcl?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#read_only StoragegatewaySmbFileShare#read_only}.
     *
     * @stability stable
     */
    readonly readOnly?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#requester_pays StoragegatewaySmbFileShare#requester_pays}.
     *
     * @stability stable
     */
    readonly requesterPays?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#role_arn StoragegatewaySmbFileShare#role_arn}.
     *
     * @stability stable
     */
    readonly roleArn: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#smb_acl_enabled StoragegatewaySmbFileShare#smb_acl_enabled}.
     *
     * @stability stable
     */
    readonly smbAclEnabled?: boolean;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#tags StoragegatewaySmbFileShare#tags}.
     *
     * @stability stable
     */
    readonly tags?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#tags_all StoragegatewaySmbFileShare#tags_all}.
     *
     * @stability stable
     */
    readonly tagsAll?: {
        [key: string]: string;
    };
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#valid_user_list StoragegatewaySmbFileShare#valid_user_list}.
     *
     * @stability stable
     */
    readonly validUserList?: string[];
    /**
     * cache_attributes block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#cache_attributes StoragegatewaySmbFileShare#cache_attributes}
     *
     * @stability stable
     */
    readonly cacheAttributes?: StoragegatewaySmbFileShareCacheAttributes[];
    /**
     * timeouts block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#timeouts StoragegatewaySmbFileShare#timeouts}
     *
     * @stability stable
     */
    readonly timeouts?: StoragegatewaySmbFileShareTimeouts;
}
/**
 * @stability stable
 */
export interface StoragegatewaySmbFileShareCacheAttributes {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#cache_stale_timeout_in_seconds StoragegatewaySmbFileShare#cache_stale_timeout_in_seconds}.
     *
     * @stability stable
     */
    readonly cacheStaleTimeoutInSeconds?: number;
}
/**
 * @stability stable
 */
export interface StoragegatewaySmbFileShareTimeouts {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#create StoragegatewaySmbFileShare#create}.
     *
     * @stability stable
     */
    readonly create?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#delete StoragegatewaySmbFileShare#delete}.
     *
     * @stability stable
     */
    readonly delete?: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html#update StoragegatewaySmbFileShare#update}.
     *
     * @stability stable
     */
    readonly update?: string;
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html aws_storagegateway_smb_file_share}.
 *
 * @stability stable
 */
export declare class StoragegatewaySmbFileShare extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/storagegateway_smb_file_share.html aws_storagegateway_smb_file_share} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: StoragegatewaySmbFileShareConfig);
    private _accessBasedEnumeration?;
    /**
     * @stability stable
     */
    get accessBasedEnumeration(): boolean;
    /**
     * @stability stable
     */
    set accessBasedEnumeration(value: boolean);
    /**
     * @stability stable
     */
    resetAccessBasedEnumeration(): void;
    /**
     * @stability stable
     */
    get accessBasedEnumerationInput(): boolean | undefined;
    private _adminUserList?;
    /**
     * @stability stable
     */
    get adminUserList(): string[];
    /**
     * @stability stable
     */
    set adminUserList(value: string[]);
    /**
     * @stability stable
     */
    resetAdminUserList(): void;
    /**
     * @stability stable
     */
    get adminUserListInput(): string[] | undefined;
    /**
     * @stability stable
     */
    get arn(): string;
    private _auditDestinationArn?;
    /**
     * @stability stable
     */
    get auditDestinationArn(): string;
    /**
     * @stability stable
     */
    set auditDestinationArn(value: string);
    /**
     * @stability stable
     */
    resetAuditDestinationArn(): void;
    /**
     * @stability stable
     */
    get auditDestinationArnInput(): string | undefined;
    private _authentication?;
    /**
     * @stability stable
     */
    get authentication(): string;
    /**
     * @stability stable
     */
    set authentication(value: string);
    /**
     * @stability stable
     */
    resetAuthentication(): void;
    /**
     * @stability stable
     */
    get authenticationInput(): string | undefined;
    private _caseSensitivity?;
    /**
     * @stability stable
     */
    get caseSensitivity(): string;
    /**
     * @stability stable
     */
    set caseSensitivity(value: string);
    /**
     * @stability stable
     */
    resetCaseSensitivity(): void;
    /**
     * @stability stable
     */
    get caseSensitivityInput(): string | undefined;
    private _defaultStorageClass?;
    /**
     * @stability stable
     */
    get defaultStorageClass(): string;
    /**
     * @stability stable
     */
    set defaultStorageClass(value: string);
    /**
     * @stability stable
     */
    resetDefaultStorageClass(): void;
    /**
     * @stability stable
     */
    get defaultStorageClassInput(): string | undefined;
    private _fileShareName?;
    /**
     * @stability stable
     */
    get fileShareName(): string;
    /**
     * @stability stable
     */
    set fileShareName(value: string);
    /**
     * @stability stable
     */
    resetFileShareName(): void;
    /**
     * @stability stable
     */
    get fileShareNameInput(): string | undefined;
    /**
     * @stability stable
     */
    get fileshareId(): string;
    private _gatewayArn;
    /**
     * @stability stable
     */
    get gatewayArn(): string;
    /**
     * @stability stable
     */
    set gatewayArn(value: string);
    /**
     * @stability stable
     */
    get gatewayArnInput(): string;
    private _guessMimeTypeEnabled?;
    /**
     * @stability stable
     */
    get guessMimeTypeEnabled(): boolean;
    /**
     * @stability stable
     */
    set guessMimeTypeEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetGuessMimeTypeEnabled(): void;
    /**
     * @stability stable
     */
    get guessMimeTypeEnabledInput(): boolean | undefined;
    /**
     * @stability stable
     */
    get id(): string;
    private _invalidUserList?;
    /**
     * @stability stable
     */
    get invalidUserList(): string[];
    /**
     * @stability stable
     */
    set invalidUserList(value: string[]);
    /**
     * @stability stable
     */
    resetInvalidUserList(): void;
    /**
     * @stability stable
     */
    get invalidUserListInput(): string[] | undefined;
    private _kmsEncrypted?;
    /**
     * @stability stable
     */
    get kmsEncrypted(): boolean;
    /**
     * @stability stable
     */
    set kmsEncrypted(value: boolean);
    /**
     * @stability stable
     */
    resetKmsEncrypted(): void;
    /**
     * @stability stable
     */
    get kmsEncryptedInput(): boolean | undefined;
    private _kmsKeyArn?;
    /**
     * @stability stable
     */
    get kmsKeyArn(): string;
    /**
     * @stability stable
     */
    set kmsKeyArn(value: string);
    /**
     * @stability stable
     */
    resetKmsKeyArn(): void;
    /**
     * @stability stable
     */
    get kmsKeyArnInput(): string | undefined;
    private _locationArn;
    /**
     * @stability stable
     */
    get locationArn(): string;
    /**
     * @stability stable
     */
    set locationArn(value: string);
    /**
     * @stability stable
     */
    get locationArnInput(): string;
    private _notificationPolicy?;
    /**
     * @stability stable
     */
    get notificationPolicy(): string;
    /**
     * @stability stable
     */
    set notificationPolicy(value: string);
    /**
     * @stability stable
     */
    resetNotificationPolicy(): void;
    /**
     * @stability stable
     */
    get notificationPolicyInput(): string | undefined;
    private _objectAcl?;
    /**
     * @stability stable
     */
    get objectAcl(): string;
    /**
     * @stability stable
     */
    set objectAcl(value: string);
    /**
     * @stability stable
     */
    resetObjectAcl(): void;
    /**
     * @stability stable
     */
    get objectAclInput(): string | undefined;
    /**
     * @stability stable
     */
    get path(): string;
    private _readOnly?;
    /**
     * @stability stable
     */
    get readOnly(): boolean;
    /**
     * @stability stable
     */
    set readOnly(value: boolean);
    /**
     * @stability stable
     */
    resetReadOnly(): void;
    /**
     * @stability stable
     */
    get readOnlyInput(): boolean | undefined;
    private _requesterPays?;
    /**
     * @stability stable
     */
    get requesterPays(): boolean;
    /**
     * @stability stable
     */
    set requesterPays(value: boolean);
    /**
     * @stability stable
     */
    resetRequesterPays(): void;
    /**
     * @stability stable
     */
    get requesterPaysInput(): boolean | undefined;
    private _roleArn;
    /**
     * @stability stable
     */
    get roleArn(): string;
    /**
     * @stability stable
     */
    set roleArn(value: string);
    /**
     * @stability stable
     */
    get roleArnInput(): string;
    private _smbAclEnabled?;
    /**
     * @stability stable
     */
    get smbAclEnabled(): boolean;
    /**
     * @stability stable
     */
    set smbAclEnabled(value: boolean);
    /**
     * @stability stable
     */
    resetSmbAclEnabled(): void;
    /**
     * @stability stable
     */
    get smbAclEnabledInput(): boolean | undefined;
    private _tags?;
    /**
     * @stability stable
     */
    get tags(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tags(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTags(): void;
    /**
     * @stability stable
     */
    get tagsInput(): {
        [key: string]: string;
    } | undefined;
    private _tagsAll?;
    /**
     * @stability stable
     */
    get tagsAll(): {
        [key: string]: string;
    };
    /**
     * @stability stable
     */
    set tagsAll(value: {
        [key: string]: string;
    });
    /**
     * @stability stable
     */
    resetTagsAll(): void;
    /**
     * @stability stable
     */
    get tagsAllInput(): {
        [key: string]: string;
    } | undefined;
    private _validUserList?;
    /**
     * @stability stable
     */
    get validUserList(): string[];
    /**
     * @stability stable
     */
    set validUserList(value: string[]);
    /**
     * @stability stable
     */
    resetValidUserList(): void;
    /**
     * @stability stable
     */
    get validUserListInput(): string[] | undefined;
    private _cacheAttributes?;
    /**
     * @stability stable
     */
    get cacheAttributes(): StoragegatewaySmbFileShareCacheAttributes[];
    /**
     * @stability stable
     */
    set cacheAttributes(value: StoragegatewaySmbFileShareCacheAttributes[]);
    /**
     * @stability stable
     */
    resetCacheAttributes(): void;
    /**
     * @stability stable
     */
    get cacheAttributesInput(): StoragegatewaySmbFileShareCacheAttributes[] | undefined;
    private _timeouts?;
    /**
     * @stability stable
     */
    get timeouts(): StoragegatewaySmbFileShareTimeouts;
    /**
     * @stability stable
     */
    set timeouts(value: StoragegatewaySmbFileShareTimeouts);
    /**
     * @stability stable
     */
    resetTimeouts(): void;
    /**
     * @stability stable
     */
    get timeoutsInput(): StoragegatewaySmbFileShareTimeouts | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
