import { Construct } from 'constructs';
import * as cdktf from 'cdktf';
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationConfig extends cdktf.TerraformMetaArguments {
    /**
     * AWS Kinesis Firehose Delivery Stream ARNs.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#log_destination_configs Wafv2WebAclLoggingConfiguration#log_destination_configs}
     *
     * @stability stable
     */
    readonly logDestinationConfigs: string[];
    /**
     * AWS WebACL ARN.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#resource_arn Wafv2WebAclLoggingConfiguration#resource_arn}
     *
     * @stability stable
     */
    readonly resourceArn: string;
    /**
     * logging_filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#logging_filter Wafv2WebAclLoggingConfiguration#logging_filter}
     *
     * @stability stable
     */
    readonly loggingFilter?: Wafv2WebAclLoggingConfigurationLoggingFilter[];
    /**
     * redacted_fields block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#redacted_fields Wafv2WebAclLoggingConfiguration#redacted_fields}
     *
     * @stability stable
     */
    readonly redactedFields?: Wafv2WebAclLoggingConfigurationRedactedFields[];
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationLoggingFilterFilterConditionActionCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#action Wafv2WebAclLoggingConfiguration#action}.
     *
     * @stability stable
     */
    readonly action: string;
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationLoggingFilterFilterConditionLabelNameCondition {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#label_name Wafv2WebAclLoggingConfiguration#label_name}.
     *
     * @stability stable
     */
    readonly labelName: string;
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationLoggingFilterFilterCondition {
    /**
     * action_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#action_condition Wafv2WebAclLoggingConfiguration#action_condition}
     *
     * @stability stable
     */
    readonly actionCondition?: Wafv2WebAclLoggingConfigurationLoggingFilterFilterConditionActionCondition[];
    /**
     * label_name_condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#label_name_condition Wafv2WebAclLoggingConfiguration#label_name_condition}
     *
     * @stability stable
     */
    readonly labelNameCondition?: Wafv2WebAclLoggingConfigurationLoggingFilterFilterConditionLabelNameCondition[];
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationLoggingFilterFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#behavior Wafv2WebAclLoggingConfiguration#behavior}.
     *
     * @stability stable
     */
    readonly behavior: string;
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#requirement Wafv2WebAclLoggingConfiguration#requirement}.
     *
     * @stability stable
     */
    readonly requirement: string;
    /**
     * condition block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#condition Wafv2WebAclLoggingConfiguration#condition}
     *
     * @stability stable
     */
    readonly condition: Wafv2WebAclLoggingConfigurationLoggingFilterFilterCondition[];
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationLoggingFilter {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#default_behavior Wafv2WebAclLoggingConfiguration#default_behavior}.
     *
     * @stability stable
     */
    readonly defaultBehavior: string;
    /**
     * filter block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#filter Wafv2WebAclLoggingConfiguration#filter}
     *
     * @stability stable
     */
    readonly filter: Wafv2WebAclLoggingConfigurationLoggingFilterFilter[];
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsAllQueryArguments {
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsBody {
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsMethod {
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsQueryString {
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsSingleHeader {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#name Wafv2WebAclLoggingConfiguration#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsSingleQueryArgument {
    /**
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#name Wafv2WebAclLoggingConfiguration#name}.
     *
     * @stability stable
     */
    readonly name: string;
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFieldsUriPath {
}
/**
 * @stability stable
 */
export interface Wafv2WebAclLoggingConfigurationRedactedFields {
    /**
     * all_query_arguments block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#all_query_arguments Wafv2WebAclLoggingConfiguration#all_query_arguments}
     *
     * @stability stable
     */
    readonly allQueryArguments?: Wafv2WebAclLoggingConfigurationRedactedFieldsAllQueryArguments[];
    /**
     * body block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#body Wafv2WebAclLoggingConfiguration#body}
     *
     * @stability stable
     */
    readonly body?: Wafv2WebAclLoggingConfigurationRedactedFieldsBody[];
    /**
     * method block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#method Wafv2WebAclLoggingConfiguration#method}
     *
     * @stability stable
     */
    readonly method?: Wafv2WebAclLoggingConfigurationRedactedFieldsMethod[];
    /**
     * query_string block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#query_string Wafv2WebAclLoggingConfiguration#query_string}
     *
     * @stability stable
     */
    readonly queryString?: Wafv2WebAclLoggingConfigurationRedactedFieldsQueryString[];
    /**
     * single_header block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#single_header Wafv2WebAclLoggingConfiguration#single_header}
     *
     * @stability stable
     */
    readonly singleHeader?: Wafv2WebAclLoggingConfigurationRedactedFieldsSingleHeader[];
    /**
     * single_query_argument block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#single_query_argument Wafv2WebAclLoggingConfiguration#single_query_argument}
     *
     * @stability stable
     */
    readonly singleQueryArgument?: Wafv2WebAclLoggingConfigurationRedactedFieldsSingleQueryArgument[];
    /**
     * uri_path block.
     *
     * Docs at Terraform Registry: {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html#uri_path Wafv2WebAclLoggingConfiguration#uri_path}
     *
     * @stability stable
     */
    readonly uriPath?: Wafv2WebAclLoggingConfigurationRedactedFieldsUriPath[];
}
/**
 * Represents a {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html aws_wafv2_web_acl_logging_configuration}.
 *
 * @stability stable
 */
export declare class Wafv2WebAclLoggingConfiguration extends cdktf.TerraformResource {
    /**
     * Create a new {@link https://www.terraform.io/docs/providers/aws/r/wafv2_web_acl_logging_configuration.html aws_wafv2_web_acl_logging_configuration} Resource.
     *
     * @param scope The scope in which to define this construct.
     * @param id The scoped construct ID.
     * @stability stable
     */
    constructor(scope: Construct, id: string, config: Wafv2WebAclLoggingConfigurationConfig);
    /**
     * @stability stable
     */
    get id(): string;
    private _logDestinationConfigs;
    /**
     * @stability stable
     */
    get logDestinationConfigs(): string[];
    /**
     * @stability stable
     */
    set logDestinationConfigs(value: string[]);
    /**
     * @stability stable
     */
    get logDestinationConfigsInput(): string[];
    private _resourceArn;
    /**
     * @stability stable
     */
    get resourceArn(): string;
    /**
     * @stability stable
     */
    set resourceArn(value: string);
    /**
     * @stability stable
     */
    get resourceArnInput(): string;
    private _loggingFilter?;
    /**
     * @stability stable
     */
    get loggingFilter(): Wafv2WebAclLoggingConfigurationLoggingFilter[];
    /**
     * @stability stable
     */
    set loggingFilter(value: Wafv2WebAclLoggingConfigurationLoggingFilter[]);
    /**
     * @stability stable
     */
    resetLoggingFilter(): void;
    /**
     * @stability stable
     */
    get loggingFilterInput(): Wafv2WebAclLoggingConfigurationLoggingFilter[] | undefined;
    private _redactedFields?;
    /**
     * @stability stable
     */
    get redactedFields(): Wafv2WebAclLoggingConfigurationRedactedFields[];
    /**
     * @stability stable
     */
    set redactedFields(value: Wafv2WebAclLoggingConfigurationRedactedFields[]);
    /**
     * @stability stable
     */
    resetRedactedFields(): void;
    /**
     * @stability stable
     */
    get redactedFieldsInput(): Wafv2WebAclLoggingConfigurationRedactedFields[] | undefined;
    /**
     * @stability stable
     */
    protected synthesizeAttributes(): {
        [name: string]: any;
    };
}
